Bug 1129429 - Review Request: ccnet - A framework for writing networked applications in C
Summary: Review Request: ccnet - A framework for writing networked applications in C
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Julien Enselme
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1129224
Blocks: 1160671
TreeView+ depends on / blocked
 
Reported: 2014-08-12 18:09 UTC by Nikos Roussos
Modified: 2016-01-19 23:56 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-01-19 23:30:06 UTC
jujens: fedora-review+


Attachments (Terms of Use)

Description Nikos Roussos 2014-08-12 18:09:27 UTC
Spec URL: https://comzeradd.fedorapeople.org/specs/ccnet.spec
SRPM URL: https://comzeradd.fedorapeople.org/srpms/ccnet-3.1.4-1.fc20.src.rpm
Description: A framework for writing networked applications in C
Fedora Account System Username: comzeradd

Comment 1 Nikos Roussos 2014-11-05 11:11:48 UTC
Updated to latest to build seafile 3.1.8

SPEC: https://comzeradd.fedorapeople.org/specs/ccnet.spec
SRPM: https://comzeradd.fedorapeople.org/srpms/ccnet-3.1.8-1.fc21.src.rpm

Comment 2 Vladimir Stackov 2014-12-16 09:48:11 UTC
Greetings,

a few comments on this review request:

1. Your packages (seafile and ccnet) both introduces build time requirements (cross-package BuildRequires) so you should setup boostraping properly:
https://fedoraproject.org/wiki/Packaging:Guidelines#Bootstrapping

2. As you are packaging snapshot, you should use another name for the package:
https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Snapshot_packages
https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/SourceURL#Github

3. You should consider using %makeinstall macros instead of make install DESTDIR=%{buildroot}:
# rpm -E %makeinstall

4. You should consider enabling hardened builds:
https://fedoraproject.org/wiki/Packaging:Guidelines#PIE

5. You should use %license for license information instead of %doc.

Please note that this is informal review.

Comment 3 Nikos Roussos 2015-04-11 12:10:34 UTC
Update to 4.1.4

SPEC: https://comzeradd.fedorapeople.org/specs/ccnet.spec
SRPM: https://comzeradd.fedorapeople.org/srpms/ccnet-4.1.4-1.fc21.src.rpm

Also address some things from above comment:

2. Use release tag instead of commit
3. Packaging guidelines discourage use of %makeinstall https://fedoraproject.org/wiki/Packaging:Guidelines#Why_the_.25makeinstall_macro_should_not_be_used
4. Enabled hardened build
5. Use %license for the LICENSE text

Comment 4 Nikos Roussos 2015-04-11 12:11:56 UTC
(In reply to Vladimir Stackov from comment #2)
> Your packages (seafile and ccnet) both introduces build time requirements
> (cross-package BuildRequires) so you should setup boostraping properly:
> https://fedoraproject.org/wiki/Packaging:Guidelines#Bootstrapping

I'm not familiar with Bootsrapping. Both seafile and ccnet depend on libsearpc. How this is a circular dependency?

Comment 6 Julien Enselme 2015-09-19 14:31:23 UTC
Some remarks:

- Version of so files looks incorrect: /usr/lib64/libccnet.so.0.0.0, /usr/lib64/libccnet.so.0 Shouldn't this be /usr/lib64/libccnet.so.4.3.4 and /usr/lib64/libccnet.so.4?


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package contains BR: python2-devel or python3-devel


===== MUST items =====

C/C++:
[X]: Package does not contain kernel modules.
[X]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[X]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "ISC", "Unknown or generated". 200 files have
     unknown license. Detailed output of licensecheck in
     /tmp/1129429-ccnet/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
- %license in devel is missing

[!]: %build honors applicable compiler flags or justifies otherwise.
Your are missing the  %{optflags} macro (you should add it to libsearpc, I missed that while reviewing). See: https://fedoraproject.org/wiki/Packaging:Guidelines#Compiler_flags. I think you should add %{?_smp_mflags} too.

[X]: Package contains no bundled libraries without FPC exception.
[X]: Changelog in prescribed format.
[X]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[X]: Development files must be in a -devel package
[X]: Package uses nothing in %doc for runtime.
[X]: Package consistently uses macros (instead of hard-coded directory
     names).
[X]: Package is named according to the Package Naming Guidelines.
[X]: Package does not generate any conflict.
[X]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
According to the readme, libzdb >= 2.10.2 is needed to build this package.

[X]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[X]: Useful -debuginfo package or justification otherwise.
[X]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[X]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[X]: Python eggs must not download any dependencies during the build
     process.
[X]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
- I belive that BR: python2-devel is required
- In %files, %{python_sitearch}/%{name} -> %{python2_sitearch}/%{name} (note the 2)

[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
See my comment above.

[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[X]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
You should update to 4.4.0

[X]: Package does not include license text files separate from upstream.
[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[X]: %check is present and all tests pass.
[X]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ccnet-4.3.4-1.fc24.x86_64.rpm
          ccnet-devel-4.3.4-1.fc24.x86_64.rpm
          ccnet-4.3.4-1.fc24.src.rpm
ccnet.x86_64: W: shared-lib-calls-exit /usr/lib64/libccnet.so.0.0.0 exit@GLIBC_2.2.5
ccnet.x86_64: W: no-manual-page-for-binary ccnet-servtool
ccnet.x86_64: W: no-manual-page-for-binary ccnet-tool
ccnet.x86_64: W: no-manual-page-for-binary ccnet-init
ccnet.x86_64: W: no-manual-page-for-binary ccnet
ccnet-devel.x86_64: W: only-non-binary-in-usr-lib
ccnet-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 7 warnings.




Rpmlint (debuginfo)
-------------------
Checking: ccnet-debuginfo-4.3.4-1.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
ccnet-devel.x86_64: W: only-non-binary-in-usr-lib
ccnet-devel.x86_64: W: no-documentation
ccnet.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libccnet.so.0.0.0 /lib64/libssl.so.10
ccnet.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libccnet.so.0.0.0 /lib64/libcrypto.so.10
ccnet.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libccnet.so.0.0.0 /lib64/libsqlite3.so.0
ccnet.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libccnet.so.0.0.0 /lib64/libgio-2.0.so.0
ccnet.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libccnet.so.0.0.0 /lib64/libjansson.so.4
** Maybe you can look at http://fedoraproject.org/wiki/Common_Rpmlint_issues#unused-direct-shlib-dependency to get rid of these.

ccnet.x86_64: W: shared-lib-calls-exit /usr/lib64/libccnet.so.0.0.0 exit@GLIBC_2.2.5
ccnet.x86_64: W: no-manual-page-for-binary ccnet-init
ccnet.x86_64: W: no-manual-page-for-binary ccnet-servtool
ccnet.x86_64: W: no-manual-page-for-binary ccnet
ccnet.x86_64: W: no-manual-page-for-binary ccnet-tool
3 packages and 0 specfiles checked; 0 errors, 12 warnings.



Requires
--------
ccnet-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    ccnet(x86-64)
    glib2-devel
    libccnet.so.0()(64bit)
    libevent-devel
    libsearpc-devel
    pkgconfig(glib-2.0)
    pkgconfig(gobject-2.0)

ccnet (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libccnet.so.0()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libevent-2.0.so.5()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libjansson.so.4()(64bit)
    libpthread.so.0()(64bit)
    libresolv.so.2()(64bit)
    libsearpc.so.1()(64bit)
    libsqlite3.so.0()(64bit)
    libssl.so.10()(64bit)
    libuuid.so.1()(64bit)
    libuuid.so.1(UUID_1.0)(64bit)
    python(abi)
    rtld(GNU_HASH)



Provides
--------
ccnet-devel:
    ccnet-devel
    ccnet-devel(x86-64)
    pkgconfig(libccnet)

ccnet:
    ccnet
    ccnet(x86-64)
    libccnet.so.0()(64bit)



Source checksums
----------------
https://github.com/haiwen/ccnet/archive/v4.3.4.tar.gz :
  CHECKSUM(SHA256) this package     : 138d6de92388440ce378fc923c50674b80f823e3d2396254dc6c60da5daf2a09
  CHECKSUM(SHA256) upstream package : 138d6de92388440ce378fc923c50674b80f823e3d2396254dc6c60da5daf2a09


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1129429
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 7 Ralf Corsepius 2015-11-02 18:48:19 UTC
(In reply to Julien Enselme from comment #6)
> Some remarks:
> 
> - Version of so files looks incorrect: /usr/lib64/libccnet.so.0.0.0,
> /usr/lib64/libccnet.so.0 Shouldn't this be /usr/lib64/libccnet.so.4.3.4 and
> /usr/lib64/libccnet.so.4?

No. Library version numbers and package version numbers actually are not connected at all (cf. info libtool). 

So, even though using "0.0.0" is likely to bug upstream and Fedora at some time in future (e.g. when upstream changes the API/ABI), using "0.0.0" is technically correct.


Additional remark:
I'd recommend to change Source0 into this:
Source0:        https://github.com/haiwen/%{name}/archive/v%{version}.tar.gz#/ccnet-%{version}.tar.gz

Comment 8 Julien Enselme 2015-11-03 09:09:00 UTC
(In reply to Ralf Corsepius from comment #7)
> (In reply to Julien Enselme from comment #6)
> > Some remarks:
> > 
> > - Version of so files looks incorrect: /usr/lib64/libccnet.so.0.0.0,
> > /usr/lib64/libccnet.so.0 Shouldn't this be /usr/lib64/libccnet.so.4.3.4 and
> > /usr/lib64/libccnet.so.4?
> 
> No. Library version numbers and package version numbers actually are not
> connected at all (cf. info libtool). 
> 
> So, even though using "0.0.0" is likely to bug upstream and Fedora at some
> time in future (e.g. when upstream changes the API/ABI), using "0.0.0" is
> technically correct.
>

Thanks for you explainations. This point looks good then.

Comment 9 Julien Enselme 2015-11-27 12:45:29 UTC
Any progress on that package?

Comment 10 Nikos Roussos 2015-12-03 17:52:37 UTC
Sorry for the long delay.

I updated the spec with fixes based on the review above. Package also updated to latest upstream version.
SPEC: https://comzeradd.fedorapeople.org/specs/ccnet.spec
SRPM: https://comzeradd.fedorapeople.org/srpms/ccnet-5.0.0-1.fc23.src.rpm

Comment 11 Julien Enselme 2015-12-04 10:54:10 UTC
Looks good. Approved.

Comment 12 Gwyn Ciesla 2015-12-04 13:29:49 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/ccnet

Comment 13 Fedora Update System 2015-12-04 15:24:10 UTC
ccnet-5.0.0-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-13bf0049d9

Comment 14 Fedora Update System 2015-12-04 15:36:31 UTC
ccnet-5.0.0-1.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-82b600d637

Comment 15 Fedora Update System 2015-12-06 05:22:29 UTC
ccnet-5.0.0-1.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update ccnet'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-82b600d637

Comment 16 Fedora Update System 2015-12-06 17:21:20 UTC
ccnet-5.0.0-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update ccnet'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-13bf0049d9

Comment 17 Fedora Update System 2016-01-19 23:30:03 UTC
ccnet-5.0.0-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2016-01-19 23:56:38 UTC
ccnet-5.0.0-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.